#ifndef HEPVis_SoGuiPainterViewer_h
#define HEPVis_SoGuiPainterViewer_h 

#include <HEPVis/Gui/SoGui.h>

class SoPainterAction;
class SoHandleEventAction;
class SoNodeSensor;
class SoSensor;
class SbPainterX11;
class SbPainterWin;
class SbPainterQt;
class SbPainterGtk;
class SoEvent;

class SoGuiPainterViewer : public SoGuiComponent {
public:
  SoGuiPainterViewer(SoGuiWidget = NULL,
                     const char* = NULL,
                     SbBool = TRUE,
                     SbBool = TRUE);
  ~SoGuiPainterViewer();
  void setSceneGraph(SoNode*);
  SoNode* getSceneGraph() const;
  void setViewportRegion(const SbViewportRegion&);
  const SbViewportRegion& getViewportRegion() const;
  void setBackgroundColor(const SbColor&);
  const SbColor& getBackgroundColor() const;
  void producePostScript();
  void enableSort(SbBool);
private:
  SoGuiWidget buildWidget(SoGuiWidget);
  void redraw();
  void sizeChanged(const SbVec2s&);
  void processEvent(SoGuiEvent*);
  void treatMouseButton(SoEvent*);
private:
  SoGuiWidget widget;
  SoPainterAction* renderAction;
  SoHandleEventAction* handleEventAction;
  SoNode* scene;
  SoNodeSensor* sceneSensor;
  SbColor bkgColor;
  static void sceneSensorCallback(SoGuiPainterViewer*,SoSensor*);
#ifdef HEPVisXt
  SbPainterX11* painter;
  static void exposeCB(Widget,SoGuiPainterViewer*,XtPointer);
  static void resizeCB(Widget,SoGuiPainterViewer*,XtPointer);
  static void windowEventCB(Widget,SoGuiPainterViewer*,XAnyEvent*,Boolean*);
#endif
#ifdef HEPVisWin
  SbPainterWin* painter;
  static LRESULT CALLBACK windowProc(HWND,UINT,WPARAM,LPARAM);
#endif
#ifdef HEPVisQt
  SbPainterQt* painter;
#endif
#ifdef HEPVisGtk
  SbPainterGtk* painter;
#endif
};

#endif
