#ifndef Slash_fmanip_h
#define Slash_fmanip_h

#include <string>
#include <cstdlib>
#include <sstream>

#include <sys/stat.h>

namespace Slash {

inline bool tmpname(const std::string& a_dir,const std::string& a_prefix,const std::string& a_suffix,std::string& a_name){
  //  For UNIX a_dir must be a string ended with '/'. Exa : /tmp/ .
  for(int count=0;count<1000;count++) {
    std::ostringstream strm;
    strm.fill('0');
    strm.width(3);
    strm << count;
    std::string name = strm.str();
    std::string tmpnm;
    if(a_dir==".") {
      tmpnm += a_prefix;
      tmpnm += name;
      tmpnm += a_suffix;
    } else if(a_dir.size()) {
      tmpnm += a_dir;
      tmpnm += a_prefix;
      tmpnm += name;
      tmpnm += a_suffix;
    } else {
#ifdef WIN32
      char* env = ::getenv("HOMEDRIVE");
      std::string drive = (env? env : std::string("C:"));
      tmpnm += drive;
      tmpnm += "\\";
      tmpnm += a_prefix;
      tmpnm += name;
      tmpnm += a_suffix;
#else
      tmpnm += "/tmp/";
      tmpnm += a_prefix;
      tmpnm += name;
      tmpnm += a_suffix;
#endif
    }
    struct stat finfo;
    if(::stat(tmpnm.c_str(),&finfo) < 0) {
      // No directory or file found :
      a_name = tmpnm; // Good file name.
      return true; 
    }
  }
  // No good name found :
  a_name = "";
  return false;
}

}

#endif
