#ifndef Slash_sprintf_h
#define Slash_sprintf_h

#include <string>
#include <cstdarg>

namespace Slash {

inline bool sprintf(std::string& a_string,int a_length,const char* a_format,...){
  a_string = "";
  if(a_length<0) return false;
  if(!a_format) return false;
  char* s = new char[a_length+1];
  if(!s) return false;
  s[a_length] = '\0';
  va_list args;
  va_start(args,a_format);
  ::vsprintf(s,a_format,args);
  va_end(args);
  if(s[a_length]!='\0') {
    delete [] s;
    return false;
  }
  a_string = s;
  delete [] s;
  return true;
}


}

#endif
